#include <boost/lexical_cast.hpp>
#include <iostream>
#include <vector>
#include "Aranya.h"

using namespace std;

Aranya::Aranya(Gosu::Graphics& graphics)
{
	puntos_=0;
   inicializarImagenes(graphics);
	reiniciarValores();
   sonidoSalto_ = new Gosu::Sample (L"../audio/sonidos/salto.ogg");
   sonidoComida_ = new Gosu::Sample (L"../audio/sonidos/carga_rifle.ogg");
}


void Aranya::inicializarImagenes(Gosu::Graphics& graphics)
{
   pobreminyimi_ = new Gosu::Image(graphics, L"../graficos/aranya/muerta.png");

	movder_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/descansod.png"));
   movder_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andard1.png"));
   movder_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andard2.png"));
   movder_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andard3.png"));
   movder_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andard4.png"));
   
   movizq_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/descansoi.png"));
   movizq_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andari1.png"));
   movizq_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andari2.png"));
   movizq_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andari3.png"));
   movizq_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/andari4.png"));
   
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltod1.png"));
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltod2.png"));
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltod1.png"));
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltoi1.png"));
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltoi2.png"));
   mova_.push_back(new Gosu::Image(graphics, L"../graficos/aranya/saltoi1.png"));
}


void Aranya::reiniciarValores(bool muerta)
{
	if (muerta)
		puntos_ = puntos_/2;
   
   velX_ = VELOCIDAD_MINYIMI;
   velY_ = 0;
   posX_ = 100;
   posY_ = 295;
   w_ = 105;
   h_ = 105;
   movX_ = 0;
   md_.first = md_.second = 0;
   mi_.first = mi_.second = 0;
   ma_.first = ma_.second = 0;
   muerta_ = false;
   direccion_=0;
	saltando_ = false;
}

Gosu::Image* Aranya::pobreminyimi()
{
	return pobreminyimi_;
}

vector<Gosu::Image*>& Aranya::movder()
{
	return movder_;
}

vector<Gosu::Image*>& Aranya::movizq()
{
	return movizq_;
}

vector<Gosu::Image*>& Aranya::mova()
{
	return mova_;
}

pair<int,int>& Aranya::md()
{
	return md_;
}

pair<int,int>& Aranya::mi()
{
	return mi_;
}

pair<int,int>& Aranya::ma()
{
	return ma_;
}


Aranya::~Aranya()
{
	delete sonidoSalto_;
}


int& Aranya::direccion()
{
	return direccion_;
}

int Aranya::direccion() const
{
	return direccion_;
}

bool& Aranya::saltando()
{
	return saltando_;
}

bool Aranya::saltando() const
{
	return saltando_;
}


void Aranya::sonidoSalto()
{
	sonidoSalto_->play();
}

void Aranya::sonidoComida()
{
	sonidoComida_->play();
}

void Aranya::movX(int px)
{
   if ( (posX_+px) >= 0 && (posX_+px) <= (400-95) )
      posX_ += px;
   else
   {
      movX_ += px;
      movX_ = ( movX_ < 0 ) ? 0 : movX_;
   }
}

void Aranya::movY(int py)
{
   posY_ += py;
}

int Aranya::movX() const
{
   return movX_;
}

int Aranya::posX() const
{
   return posX_;
}

int Aranya::posY() const
{
   return posY_;
}

int Aranya::width() const
{
   return w_;
}

int Aranya::height() const
{
   return h_;
}

void Aranya::muerta(bool valor)
{
	muerta_ = valor;
}

bool Aranya::muerta()
{
	return muerta_;
}

void Aranya::come()
{
	puntos_ += COME_MOSQUITO;
}

int Aranya::puntos() const
{
   return puntos_;
}

