#include <boost/lexical_cast.hpp>
#include "Nivel.h"


Nivel::Nivel (Gosu::Graphics& graphics, int nivel) : nivel_(nivel)
{
	fin_ = new Gosu::Sample (L"../audio/sonidos/score.ogg");
	finalactivo_ = false;
	switch(nivel)
	{
		case 1:
		{
			fondo_ = new Gosu::Image(graphics, L"../graficos/niveles/1/nivel_1_1_largo.png");
			music_ = new Gosu::Song(L"../audio/musica/fondo1.ogg");

			Enemigos_.push_back(new Abeja(graphics, 300, 450, 150));
			Enemigos_.push_back(new Abeja(graphics, 900, 1850, 150));
			Enemigos_.push_back(new Abeja(graphics, 1500, 1950, 165));
			Enemigos_.push_back(new Abeja(graphics, 3600, 3900, 250));
			Enemigos_.push_back(new Abeja(graphics, 2500, 2950, 265));
			Enemigos_.push_back(new Abeja(graphics, 3200, 3550, 165));
			Enemigos_.push_back(new Abeja(graphics, 3600, 3900, 250));
			Enemigos_.push_back(new Abeja(graphics, 4100, 4300, 250));
			Enemigos_.push_back(new Abeja(graphics, 5600, 6900, 250));
			Enemigos_.push_back(new Abeja(graphics, 7380, 7550, 350));
			
			Obstaculos_.push_back(new Basura(graphics, 800, 240));
			Obstaculos_.push_back(new Basura(graphics, 2800, 240));
			Obstaculos_.push_back(new Basura(graphics, 3600, 240));
			Obstaculos_.push_back(new Basura(graphics, 3900, 240));
			Obstaculos_.push_back(new Basura(graphics, 4700, 240));
			Obstaculos_.push_back(new Basura(graphics, 6000, 240));
			Obstaculos_.push_back(new Basura(graphics, 6750, 240));

			Obstaculos_.push_back(new Arbol(graphics, 2900, 150));
			Obstaculos_.push_back(new Arbol(graphics, 4100, 150));
			Obstaculos_.push_back(new Arbol(graphics, 6900, 150));
			
			Obstaculos_.push_back(new Banco(graphics, 3050, 340));
			Obstaculos_.push_back(new Banco(graphics, 7250, 340));
			Obstaculos_.push_back(new Banco(graphics, 7550, 340));
			
			Obstaculos_.push_back(new Caja(graphics, 700, 350));
			Obstaculos_.push_back(new Caja(graphics, 2700, 350));
			Obstaculos_.push_back(new Caja(graphics, 3500, 350));
			Obstaculos_.push_back(new Caja(graphics, 3700, 350));
			Obstaculos_.push_back(new Caja(graphics, 4500, 350));
			Obstaculos_.push_back(new Caja(graphics, 4950, 350));
			Obstaculos_.push_back(new Caja(graphics, 5850, 350));
			Obstaculos_.push_back(new Caja(graphics, 6550, 350));

			Obstaculos_.push_back(new Farola(graphics, 8250, 130));

			Mosquitos_.push_back(new Mosquito(graphics,600,120));
			Mosquitos_.push_back(new Mosquito(graphics,1610,140));
			Mosquitos_.push_back(new Mosquito(graphics,2600,200));
			Mosquitos_.push_back(new Mosquito(graphics,2950,50));
			Mosquitos_.push_back(new Mosquito(graphics,3800,300));
			Mosquitos_.push_back(new Mosquito(graphics,4850,120));
			Mosquitos_.push_back(new Mosquito(graphics,4600,100));
			Mosquitos_.push_back(new Mosquito(graphics,5060,160));
			Mosquitos_.push_back(new Mosquito(graphics,5860,160));
			Mosquitos_.push_back(new Mosquito(graphics,6260,160));
			Mosquitos_.push_back(new Mosquito(graphics,7020,300));
			Mosquitos_.push_back(new Mosquito(graphics,7460,160));
			
			break;
		}
		case 2:
		{
		   fondo_ = new Gosu::Image(graphics, L"../graficos/niveles/2/fondo2.png");
			music_ = new Gosu::Song(L"../audio/musica/fondo2.ogg");
			Enemigos_.push_back(new Mosca(graphics, 340, 500, 150));
			Enemigos_.push_back(new Mosca(graphics, 900, 1200, 180));
			Enemigos_.push_back(new Mosca(graphics, 1300, 1550, 165)); 
			Enemigos_.push_back(new Mosca(graphics, 1900, 2200, 120));
			Enemigos_.push_back(new Mosca(graphics, 2500, 3000, 120));
			Enemigos_.push_back(new Mosca(graphics, 3250, 3480, 270));
			Enemigos_.push_back(new Mosca(graphics, 4200, 4700, 270));
			Enemigos_.push_back(new Mosca(graphics, 5000, 5500, 290));
			Enemigos_.push_back(new Mosca(graphics, 6100, 6500, 280));
			Enemigos_.push_back(new Mosca(graphics, 7500, 7800, 280));
			
			Obstaculos_.push_back(new Encimera(graphics, 800, 240));
			Obstaculos_.push_back(new Encimera(graphics, 1600, 240)); 
			Obstaculos_.push_back(new Encimera(graphics, 2300, 240));
			Obstaculos_.push_back(new Encimera(graphics, 3000, 240));
			Obstaculos_.push_back(new Encimera(graphics, 4500, 240));
			Obstaculos_.push_back(new Encimera(graphics, 5800, 240));
			Obstaculos_.push_back(new Encimera(graphics, 6500, 240));
			Obstaculos_.push_back(new Encimera(graphics, 7280, 240));
			
			Obstaculos_.push_back(new Sofa(graphics, 3540, 250));
			Obstaculos_.push_back(new Sofa(graphics, 7000, 270));
			
			Obstaculos_.push_back(new Estanteria(graphics,840,220));
			Obstaculos_.push_back(new Estanteria(graphics,840,205)); 
			Obstaculos_.push_back(new Estanteria(graphics,2120,350));

			Obstaculos_.push_back(new Taburete(graphics, 700, 330));
			Obstaculos_.push_back(new Taburete(graphics, 1520, 350)); 
			Obstaculos_.push_back(new Taburete(graphics, 2780, 300));
			Obstaculos_.push_back(new Taburete(graphics, 4420, 330)); 
			Obstaculos_.push_back(new Taburete(graphics, 5200, 330));
			Obstaculos_.push_back(new Taburete(graphics, 5700, 330));
			Obstaculos_.push_back(new Taburete(graphics, 6400, 330));
			
			Obstaculos_.push_back(new Lampara(graphics, 8250, 130));
			
			Mosquitos_.push_back(new Mosquito(graphics,600,300));
			Mosquitos_.push_back(new Mosquito(graphics,950,190));
			Mosquitos_.push_back(new Mosquito(graphics,1420,200)); 
			Mosquitos_.push_back(new Mosquito(graphics,1520,300)); 
			Mosquitos_.push_back(new Mosquito(graphics,1800,150));
			Mosquitos_.push_back(new Mosquito(graphics,2700,305));
			Mosquitos_.push_back(new Mosquito(graphics,2895,305)); 
			Mosquitos_.push_back(new Mosquito(graphics,4500,150));
			Mosquitos_.push_back(new Mosquito(graphics,5220,270));
			Mosquitos_.push_back(new Mosquito(graphics,6320,270));
			Mosquitos_.push_back(new Mosquito(graphics,7200,150));
			Mosquitos_.push_back(new Mosquito(graphics,7700,300));
			
			break;
		}
		default: break;
	}
}


Nivel::~Nivel ()
{
	delete fondo_;
}

void Nivel::draw (int x, int y, int z)
{
	fondo_->draw(x,y,z);
	music_->play();

   mover_enemigos(x);
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos().begin() ; i != Obstaculos().end() ; i++ )
	   (*i)->draw(x+(*i)->posX(),(*i)->posY(),1);
	   
	mover_mosquitos(x);
}

int Nivel::width() const
{
	return width_;
}


int Nivel::height() const
{
	return height_;
}


int Nivel::nivel() const
{
	return nivel_;
}

Gosu::Image* Nivel::fondo() const
{
	return fondo_;
}


bool Nivel::fin()
{
	if ( finalactivo_ )
	{
		return false;
	}
	else
	{
		finalactivo_ = true;
		music_->stop();
		fin_->play();
		return true;
	}
}

bool Nivel::finalactivo()
{
	return finalactivo_;
}

vector<Obstaculo*>::iterator Nivel::HayObstaculoDer(Aranya *minyimi)
{
   int aranyaX = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaYporarriba = minyimi->posY() + minyimi->height();
   int aranyaYporabajo = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
		if ( aranyaX == (*i)->posX() and ( not ( aranyaYporarriba <= (*i)->posY() or aranyaYporabajo >= (*i)->posY() + (*i)->height() ) ) )
		   return i;
	
	return Obstaculos_.end();
}

vector<Obstaculo*>::iterator Nivel::HayObstaculoIzq(Aranya *minyimi)
{
   int aranyaX = minyimi->movX() + minyimi->posX();
   int aranyaYporarriba = minyimi->posY() + minyimi->height();
   int aranyaYporabajo = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaX == (*i)->posX() + (*i)->width() and ( not ( aranyaYporarriba <= (*i)->posY() or aranyaYporabajo >= (*i)->posY() + (*i)->height() ) ) )
		   return i;
	
	return Obstaculos_.end();
}


vector<Obstaculo*>::iterator Nivel::HayObstaculoArriba(Aranya *minyimi)
{
   int aranyaXporizq = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaXporder = minyimi->movX() + minyimi->posX();
   int aranyaY = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaY == (*i)->posY() + (*i)->height() and ( not ( aranyaXporizq <= (*i)->posX() or aranyaXporder >= (*i)->posX() + (*i)->width() ) ) )
		   return i;
	
	return Obstaculos_.end();
}


vector<Obstaculo*>::iterator Nivel::HayObstaculoAbajo(Aranya *minyimi)
{
   int aranyaXporizq = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaXporder = minyimi->movX() + minyimi->posX();
   int aranyaY = minyimi->posY() + minyimi->height();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaY == (*i)->posY() and ( not ( aranyaXporizq <= (*i)->posX() or aranyaXporder >= (*i)->posX() + (*i)->width() ) ) )
		   return i;
		   
	return Obstaculos_.end();
}


bool Nivel::MuereMinyimiMuere(Aranya *minyimi)
{
	if ( !minyimi->muerta() )
	{
		for ( vector<Enemigo*>::iterator i = Enemigos_.begin() ; i != Enemigos_.end() ; i++ )
		{
			if ( ( minyimi->movX() + minyimi->posX() + minyimi->width() >= (*i)->posicion() and minyimi->movX() + minyimi->posX() + minyimi->width() <= (*i)->posicion() + (*i)->width() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->movY() or minyimi->posY() > (*i)->movY() + (*i)->height() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->movX() + minyimi->posX() <= (*i)->posicion() + (*i)->width() and minyimi->movX() + minyimi->posX() >= (*i)->posicion() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->movY() or minyimi->posY() > (*i)->movY() + (*i)->height() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->posY() <= (*i)->movY() + (*i)->height() and minyimi->posY() >= (*i)->movY() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posicion() or minyimi->movX() + minyimi->posX() > (*i)->posicion() + (*i)->width() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->posY() + minyimi->height() >= (*i)->movY() and minyimi->posY() + minyimi->height() <= (*i)->movY() + (*i)->height() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posicion() or minyimi->movX() + minyimi->posX() > (*i)->posicion() + (*i)->width() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
		}
		minyimi->muerta(false);
	}
   return false;
}



bool Nivel::Comida(Aranya *minyimi)
{
	if ( !minyimi->muerta() )
	{
		for ( vector<Mosquito*>::iterator i = Mosquitos_.begin() ; i != Mosquitos_.end() ; i++ )
		{
			if (! (*i)->muerto() )
			{
				if ( ( minyimi->movX() + minyimi->posX() + minyimi->width() >= (*i)->posX() and minyimi->movX() + minyimi->posX() + minyimi->width() <= (*i)->posX() + (*i)->width() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->posY() or minyimi->posY() > (*i)->posY() + (*i)->height() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->movX() + minyimi->posX() <= (*i)->posX() + (*i)->width() and minyimi->movX() + minyimi->posX() >= (*i)->posX() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->posY() or minyimi->posY() > (*i)->posY() + (*i)->height() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->posY() <= (*i)->posY() + (*i)->height() and minyimi->posY() >= (*i)->posY() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posX() or minyimi->movX() + minyimi->posX() > (*i)->posX() + (*i)->width() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->posY() + minyimi->height() >= (*i)->posY() and minyimi->posY() + minyimi->height() <= (*i)->posY() + (*i)->height() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posX() or minyimi->movX() + minyimi->posX() > (*i)->posX() + (*i)->width() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
			}
		}
	}
   return false;
}


vector<Obstaculo*>& Nivel::Obstaculos()
{
	return Obstaculos_;
}

vector<Enemigo*>& Nivel::Enemigos()
{
	return Enemigos_;
}

vector<Mosquito*>& Nivel::Mosquitos()
{
	return Mosquitos_;
}


void Nivel::mover_enemigos(int desplazamiento)
{
	for ( vector<Enemigo*>::iterator i = Enemigos().begin() ; i != Enemigos().end() ; i++ )
	{
		/// Avanzando hacia la derecha
		if((*i)->posicion() < (*i)->movX2() and (*i)->direccion() == 0)
		{
		   (*i)->control_der().second++;
			if((*i)->control_der().second % 500 != 0)
		   {
		      (*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
		   }
		   else
			{
			   (*i)->palader();
			   (*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->posicion((*i)->velX());
		}
		
		/// Girando en el rango máximo, de derecha a izquierda   
		if((*i)->posicion() >= (*i)->movX2() and (*i)->direccion() == 0)
		{
			(*i)->posicion(-(*i)->velX());
			(*i)->control_izq().second++;
			if((*i)->control_izq().second % 500 != 0)
			{
			   int draw_x = desplazamiento+(*i)->posicion();
			   int draw_y = (*i)->movY();
			   int cambio_de_imagen = (*i)->palaizq();
			   (*i)->control_izq().first[cambio_de_imagen]->draw(draw_x,draw_y,1);
			}
			else
			{
			   (*i)->palaizq();
			   (*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->direccion(1);
		}
		

		/// Retrocediendo hacia la izquierda
		if((*i)->posicion() > (*i)->movX1() and (*i)->direccion() == 1)
		{
			(*i)->control_izq().second++;
			if((*i)->control_izq().second % 500 != 0)
			{
				(*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			else
			{
				(*i)->palaizq();
				(*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->posicion(-(*i)->velX());
		}
		

		/// Girando en el rango mínimo, de izquierda a derecha   
		if((*i)->posicion() <= (*i)->movX1() and (*i)->direccion() == 1)
		{
		   (*i)->posicion((*i)->velX());
			(*i)->control_der().second++;
			if((*i)->control_der().second % 500 != 0)
			{
				(*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			else
			{
				(*i)->palader();
				(*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->direccion(0);
		} 
	}
}


void Nivel::mover_mosquitos(int desplazamiento)
{
	for ( vector<Mosquito*>::iterator i = Mosquitos().begin() ; i != Mosquitos().end() ; i++ )
	{
		(*i)->mover().second = ((*i)->mover().second+1) % 10;
 		if ( (*i)->mover().second == 0 )
 		   (*i)->mover().first = ((*i)->mover().first+1) % 2;
		
		if ( !(*i)->muerto() )
	   	(*i)->draw ( desplazamiento + (*i)->posX() , (*i)->posY() , 1 );
	}
}



Menu::Menu (Gosu::Graphics& graphics)
{
	fondo_ = new Gosu::Image(graphics, L"../graficos/fondo_menu.png");
   bjugar1_ = new Gosu::Image(graphics, L"../graficos/botones/bjugar1.png");
   bjugar2_ = new Gosu::Image(graphics, L"../graficos/botones/bjugar2.png");
   bsalir1_ = new Gosu::Image(graphics, L"../graficos/botones/bsalir1.png");
   bsalir2_ = new Gosu::Image(graphics, L"../graficos/botones/bsalir2.png");
   bcreditos1_ = new Gosu::Image(graphics, L"../graficos/botones/bcreditos1.png");
   bcreditos2_ = new Gosu::Image(graphics, L"../graficos/botones/bcreditos2.png");
   music_ = new Gosu::Song(L"../audio/musica/inicial.ogg");
	nivel11_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel11.png");
	nivel12_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel12.png");
	nivel21_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel21.png");
	nivel22_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel22.png");
	atras1_ = new Gosu::Image(graphics, L"../graficos/botones/batras1.png");
	atras2_ = new Gosu::Image(graphics, L"../graficos/botones/batras2.png");
}



Menu::~Menu()
{
	delete fondo_;
	delete bjugar1_;
	delete bjugar2_;
	delete bsalir1_;
	delete bsalir2_;
	delete music_;
	delete nivel11_;
	delete nivel12_;
	delete nivel21_;
	delete nivel22_;
	delete atras1_;
	delete atras2_;
}


void Menu::draw(double x, double y)
{
   fondo_->draw(0,0,0);
   
   if ( x >= 650 and x <= 650 + 180 and y >= 100 and y <= 100 + 110 )
	   bjugar2_->draw(650,100,1);
	else
		bjugar1_->draw(650,100,1);
		
   if ( x >= 455 and x <= 455 + 60 and y >= 240 and y <= 240 + 90 )
	   bcreditos2_->draw(455,240,1);
	else
		bcreditos1_->draw(455,240,1);		
   
   if ( x >= 650 and x <= 650 + 180 and y >= 350 and y <= 350 + 110 )
	   bsalir2_->draw(650,350,1);
   else
		bsalir1_->draw(650,350,1);
   
   music_->play();
}

void Menu::pararMusica()
{
	music_->play();
}

void Menu::niveles(double x, double y)
{
   fondo_->draw(0,0,0);
   
   if ( x >= 250 and x <= 250 + 300 and y >= 80 and y <= 80 + 65 )
		nivel12_->draw(250,80,2);
	else
		nivel11_->draw(250,80,2);

   if ( x >= 250 and x <= 250 + 300 and y >= 200 and y <= 200 + 65 )
		nivel22_->draw(250,200,2);
   else
		nivel21_->draw(250,200,2);

   if ( x >= 250 and x <= 250 + 300 and y >= 320 and y <= 320 + 65 )
		atras2_->draw(250,320,2);
   else
		atras1_->draw(250,320,2);
}

int Menu::escogernivel(int ratonX, int ratonY)
{
   int eleccion = 0;
   
   if(ratonX >= 250 and ratonX <= 250 + 300 and ratonY >= 80 and ratonY <= 80 + 65)
		eleccion = 1;
   else if(ratonX >= 250 and ratonX <= 250 + 300 and ratonY >= 200 and ratonY <= 200 + 65)
	   eleccion = 2;
   else if(ratonX >= 250 and ratonX <= 250 + 300 and ratonY >= 320 and ratonY <= 320 + 65)
	   eleccion = 0;
	   
	return eleccion;
}

